;*********************************************************************************************************
;**** BIN2HEX
;*********************************************************************************************************
; USES: T1, (W)->(W)
BIN2HEX:
        addlw   .48
	movwf	T1
        movlw   .58
	subwf	T1,w
	btfss	STATUS,C
	goto	B2H_1		; G vidare om <10 [0..9]
        movlw   .7              ; >=10 ---> +55 ---> [A..F]
	addwf	T1,f
B2H_1:  movf    T1,w
	RETURN



;*********************************************************************************************************
;**** BIN2BCD
;*********************************************************************************************************
; USES: _N, T3, (C1,C0)->(T0,T1,T2)

BIN2BCD bcf     STATUS,0
        movlw   .16
        movwf   _N
        clrf    T0
        clrf    T1
        clrf    T2

loop16  rlf     C0,1
        rlf     C1,1
        rlf     T2,1
        rlf     T1,1
        rlf     T0,1
        decfsz  _N,1
        goto    adjDEC
        RETLW   0

adjDEC  movlw   T2
        movwf   FSR
        call    BCDADJ
        movlw   T1
        movwf   FSR
        call    BCDADJ
        movlw   T0
        movwf   FSR
        call    BCDADJ
        goto    loop16


BCDADJ  movlw   3
        addwf   0,0
        movwf   T3
        btfsc   T3,3
        movwf   0
        movlw   0x30
        addwf   0,0
        movwf   T3
        btfsc   T3,7
        movwf   0
        retlw   0



